//==============================================================
// O[oϐ
float4x4 mW; // [hs
float4x4 mLV; // Cgp̃r[s
float4x4 mLP; // Cgp̎ˉes

texture MeshTex; // }eÃeNX`

sampler MeshSmp = sampler_state
{
    Texture = <MeshTex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = LINEAR;
    AddressU = Wrap;
    AddressV = Wrap;
};

//==============================================================
// VF[_iVhE}bv̕`j

struct VS_OUTPUT
{
    float4 Pos : POSITION;
    float2 Depth : TEXCOORD0;
    float2 MeshUV : TEXCOORD1;
};

// _VF[_
VS_OUTPUT ShadowMapVS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0
)
    {
    VS_OUTPUT Out;

	// _WCgɑ΂Ďˉeϊ
    Out.Pos = mul(pos, mW);
    Out.Pos = mul(Out.Pos, mLV);
    Out.Pos = mul(Out.Pos, mLP);

	// Ổ̕êh~
    Out.Pos.z = max(0, Out.Pos.z);
	
    Out.MeshUV = mesh_uv;
	
	// [x
    Out.Depth.xy = Out.Pos.zw;
	
    return Out;
    }

// sNZVF[_
float4 ShadowMapPS (VS_OUTPUT In) : COLOR
    {
	// eXg
    clip(tex2D(MeshSmp, In.MeshUV).a - 0.01);

    return In.Depth.x / In.Depth.y;
    };


//==============================================================
// eNjbN

technique Tech
{
    pass P0
    {
        AlphaBlendEnable = false;

        VertexShader = compile vs_3_0 ShadowMapVS();
        PixelShader = compile ps_3_0 ShadowMapPS();
    }
};
